Index: palm/trunk/SCRIPTS/mrun
===================================================================
--- palm/trunk/SCRIPTS/mrun	(revision 1106)
+++ palm/trunk/SCRIPTS/mrun	(revision 1107)
@@ -22,10 +22,13 @@
 # Current revisions:
 # ------------------
-# --stdin argument for mpiexec on lckyuh
-# -y and -Y settings output to header
+# 
 #
 # Former revisions:
 # -----------------
 # $Id$
+#
+# 1106 2013-03-04 05:31:38Z raasch
+# --stdin argument for mpiexec on lckyuh
+# -y and -Y settings output to header
 #
 # 1103 2013-02-20 02:15:53Z raasch
Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1106)
+++ palm/trunk/SOURCE/Makefile	(revision 1107)
@@ -20,9 +20,12 @@
 # Current revisions:
 # ------------------
-# +cuda_fft_interfaces
+# 
 #
 # Former revisions:
 # -----------------
 # $Id$
+#
+# 1106 2013-03-04 05:31:38Z raasch
+# +cuda_fft_interfaces
 #
 # 1053 2012-11-13 17:11:03Z hoffmann
Index: palm/trunk/SOURCE/Makefile_check
===================================================================
--- palm/trunk/SOURCE/Makefile_check	(revision 1106)
+++ palm/trunk/SOURCE/Makefile_check	(revision 1107)
@@ -20,9 +20,12 @@
 # Current revisions:
 # ------------------
-# +cuda_fft_interfaces
+# 
 #
 # Former revisions:
 # -----------------
 # $Id$
+#
+# 1106 2013-03-04 05:31:38Z raasch
+# +cuda_fft_interfaces
 #
 # 1036 2012-10-22 13:43:42Z raasch
Index: palm/trunk/SOURCE/check_open.f90
===================================================================
--- palm/trunk/SOURCE/check_open.f90	(revision 1106)
+++ palm/trunk/SOURCE/check_open.f90	(revision 1107)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! array_kind renamed precision_kind
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1106 2013-03-04 05:31:38Z raasch
+! array_kind renamed precision_kind
 !
 ! 1092 2013-02-02 11:24:22Z raasch
Index: palm/trunk/SOURCE/cuda_fft_interfaces.f90
===================================================================
--- palm/trunk/SOURCE/cuda_fft_interfaces.f90	(revision 1106)
+++ palm/trunk/SOURCE/cuda_fft_interfaces.f90	(revision 1107)
@@ -26,4 +26,6 @@
 ! $Id$
 !
+! 1106 2013-03-04 05:31:38Z raasch
+! Initial revision
 !
 ! Description:
Index: palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_3d.f90	(revision 1106)
+++ palm/trunk/SOURCE/data_output_3d.f90	(revision 1107)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! array_kind renamed precision_kind
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1106 2013-03-04 05:31:38Z raasch
+! array_kind renamed precision_kind
 !
 ! 1076 2012-12-05 08:30:18Z hoffmann
Index: palm/trunk/SOURCE/data_output_profiles.f90
===================================================================
--- palm/trunk/SOURCE/data_output_profiles.f90	(revision 1106)
+++ palm/trunk/SOURCE/data_output_profiles.f90	(revision 1107)
@@ -20,9 +20,13 @@
 ! Current revisions:
 ! -----------------
-! bugfix: initial time for preruns of coupled runs is output as -coupling_start_time
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1106 2013-03-04 05:31:38Z raasch
+! bugfix: initial time for preruns of coupled runs is output as
+! -coupling_start_time
 !
 ! 1092 2013-02-02 11:24:22Z raasch
Index: palm/trunk/SOURCE/fft_xy.f90
===================================================================
--- palm/trunk/SOURCE/fft_xy.f90	(revision 1106)
+++ palm/trunk/SOURCE/fft_xy.f90	(revision 1107)
@@ -20,11 +20,14 @@
 ! Current revisions:
 ! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1106 2013-03-04 05:31:38Z raasch
 ! CUDA fft added
 ! array_kind renamed precision_kind, 3D- instead of 1D-loops in fft_x and fft_y
 ! old fft_x, fft_y become fft_x_1d, fft_y_1d and are used for 1D-decomposition
-!
-! Former revisions:
-! -----------------
-! $Id$
 !
 ! 1092 2013-02-02 11:24:22Z raasch
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 1106)
+++ palm/trunk/SOURCE/header.f90	(revision 1107)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! some format changes for coupled runs
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1106 2013-03-04 05:31:38Z raasch
+! some format changes for coupled runs
 !
 ! 1092 2013-02-02 11:24:22Z raasch
Index: palm/trunk/SOURCE/microphysics.f90
===================================================================
--- palm/trunk/SOURCE/microphysics.f90	(revision 1106)
+++ palm/trunk/SOURCE/microphysics.f90	(revision 1107)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! small changes in code formatting
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1106 2013-03-04 05:31:38Z raasch
+! small changes in code formatting
 !
 ! 1092 2013-02-02 11:24:22Z raasch
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 1106)
+++ palm/trunk/SOURCE/modules.f90	(revision 1107)
@@ -20,12 +20,13 @@
 ! Current revisions:
 ! ------------------
-! test: different dpk definition for CUDA FFT  removed!!!! delete this comment
-! before next check in
-! array_kind renamed precision_kind, pdims defined in serial code
-! bugfix: default value assigned to coupling_start_time
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1106 2013-03-04 05:31:38Z raasch
+! array_kind renamed precision_kind, pdims defined in serial code
+! bugfix: default value assigned to coupling_start_time
 !
 ! 1095 2013-02-03 02:21:01Z raasch
Index: palm/trunk/SOURCE/poisfft.f90
===================================================================
--- palm/trunk/SOURCE/poisfft.f90	(revision 1106)
+++ palm/trunk/SOURCE/poisfft.f90	(revision 1107)
@@ -20,11 +20,14 @@
 ! Current revisions:
 ! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1106 2013-03-04 05:31:38Z raasch
 ! routines fftx, ffty, fftxp, fftyp removed, calls replaced by fft_x, fft_y,
 ! in the 1D-decomposition routines fft_x, ffty are replaced by fft_x_1d,
 ! fft_y_1d
-!
-! Former revisions:
-! -----------------
-! $Id$
 !
 ! 1103 2013-02-20 02:15:53Z raasch
Index: palm/trunk/SOURCE/poisfft_hybrid.f90
===================================================================
--- palm/trunk/SOURCE/poisfft_hybrid.f90	(revision 1106)
+++ palm/trunk/SOURCE/poisfft_hybrid.f90	(revision 1107)
@@ -20,9 +20,12 @@
 ! Current revisions: 
 ! ----------------- 
-! calls of fft_x, fft_y replaced by fft_x_1d, fft_y_1d
+! 
 !
 ! Former revisions: 
 ! ----------------- 
 ! $Id$
+!
+! 1106 2013-03-04 05:31:38Z raasch
+! calls of fft_x, fft_y replaced by fft_x_1d, fft_y_1d
 !
 ! 1036 2012-10-22 13:43:42Z raasch
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 1106)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 1107)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! small changes in code formatting
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1106 2013-03-04 05:31:38Z raasch
+! small changes in code formatting
 !
 ! 1092 2013-02-02 11:24:22Z raasch
Index: palm/trunk/SOURCE/transpose.f90
===================================================================
--- palm/trunk/SOURCE/transpose.f90	(revision 1106)
+++ palm/trunk/SOURCE/transpose.f90	(revision 1107)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! -----------------
-! preprocessor lines rearranged so that routines can also be used in serial
-! (non-parallel) mode
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1106 2013-03-04 05:31:38Z raasch
+! preprocessor lines rearranged so that routines can also be used in serial
+! (non-parallel) mode
 !
 ! 1092 2013-02-02 11:24:22Z raasch
Index: palm/trunk/SOURCE/user_data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/user_data_output_3d.f90	(revision 1106)
+++ palm/trunk/SOURCE/user_data_output_3d.f90	(revision 1107)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! array_kind renamed precision_kind
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1106 2013-03-04 05:31:38Z raasch
+! array_kind renamed precision_kind
 !
 ! 1036 2012-10-22 13:43:42Z raasch