Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1111)
+++ palm/trunk/SOURCE/Makefile	(revision 1112)
@@ -20,10 +20,13 @@
 # Current revisions:
 # ------------------
-# dependencies removed from init_pegrid
-# bugfix: dependency added for cuda_fft_interfaces
+# 
 #
 # Former revisions:
 # -----------------
 # $Id$
+#
+# 1111 2013-03-08 23:54:10Z raasch
+# dependencies removed from init_pegrid
+# bugfix: dependency added for cuda_fft_interfaces
 #
 # 1106 2013-03-04 05:31:38Z raasch
Index: palm/trunk/SOURCE/Makefile_check
===================================================================
--- palm/trunk/SOURCE/Makefile_check	(revision 1111)
+++ palm/trunk/SOURCE/Makefile_check	(revision 1112)
@@ -20,9 +20,12 @@
 # Current revisions:
 # ------------------
-# dependencies removed from init_pegrid
+# 
 #
 # Former revisions:
 # -----------------
 # $Id$
+#
+# 1111 2013-03-08 23:54:10Z raasch
+# dependencies removed from init_pegrid
 #
 # 1106 2013-03-04 05:31:38Z raasch
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 1111)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1112)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! ibc_p_b = 2 removed
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1111 2013-03-08 23:54:10Z raasch
+! ibc_p_b = 2 removed
 !
 ! 1103 2013-02-20 02:15:53Z raasch
Index: palm/trunk/SOURCE/cpu_statistics.f90
===================================================================
--- palm/trunk/SOURCE/cpu_statistics.f90	(revision 1111)
+++ palm/trunk/SOURCE/cpu_statistics.f90	(revision 1112)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! output of grid point numbers and average CPU time per grid point and timestep
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1111 2013-03-08 23:54:10Z raasch
+! output of grid point numbers and average CPU time per grid point and timestep
 !
 ! 1092 2013-02-02 11:24:22Z raasch
Index: palm/trunk/SOURCE/cuda_fft_interfaces.f90
===================================================================
--- palm/trunk/SOURCE/cuda_fft_interfaces.f90	(revision 1111)
+++ palm/trunk/SOURCE/cuda_fft_interfaces.f90	(revision 1112)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! idata and odata changed from 1d- to 3d-arrays
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1111 2013-03-08 23:54:10Z raasch
+! idata and odata changed from 1d- to 3d-arrays
 !
 ! 1106 2013-03-04 05:31:38Z raasch
Index: palm/trunk/SOURCE/fft_xy.f90
===================================================================
--- palm/trunk/SOURCE/fft_xy.f90	(revision 1111)
+++ palm/trunk/SOURCE/fft_xy.f90	(revision 1112)
@@ -20,11 +20,14 @@
 ! Current revisions:
 ! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1111 2013-03-08 23:54:10Z raasch
 ! further openACC statements added, CUDA branch completely runs on GPU
 ! bugfix: CUDA fft plans adjusted for domain decomposition (before they always
 ! used total domain)
-!
-! Former revisions:
-! -----------------
-! $Id$
 !
 ! 1106 2013-03-04 05:31:38Z raasch
Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 1111)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 1112)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! openACC directive added
+! 
 !
 ! Former revisions:
@@ -26,6 +26,9 @@
 ! $Id$
 !
+! 1111 2013-03-08 23:54:10Z raasch
+! openACC directive added
+!
 ! 1053 2012-11-13 17:11:03Z hoffmann
-! necessary additions for two-moment cloud physics scheme:
+! additions for two-moment cloud physics scheme:
 ! +nr, qr, qc, prr
 !
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 1111)
+++ palm/trunk/SOURCE/header.f90	(revision 1112)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! -----------------
-! output of accelerator board information
-! ibc_p_b = 2 removed
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1111 2013-03-08 23:54:10Z raasch
+! output of accelerator board information
+! ibc_p_b = 2 removed
 !
 ! 1108 2013-03-05 07:03:32Z raasch
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1111)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1112)
@@ -23,10 +23,13 @@
 ! Current revisions:
 ! ------------------
-! openACC directives added for pres
-! array diss allocated only if required
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1111 2013-03-08 23:54:10Z raasch
+! openACC directives added for pres
+! array diss allocated only if required
 !
 ! 1092 2013-02-02 11:24:22Z raasch
Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 1111)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 1112)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! initialization of poisfft moved to poisfft
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1111 2013-03-08 23:54:10Z raasch
+! initialization of poisfft moved to module poisfft
 !
 ! 1092 2013-02-02 11:24:22Z raasch
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 1111)
+++ palm/trunk/SOURCE/modules.f90	(revision 1112)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! +tric, nr_timesteps_this_run
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1111 2013-03-08 23:54:10Z raasch
+! +tric, nr_timesteps_this_run
 !
 ! 1106 2013-03-04 05:31:38Z raasch
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 1111)
+++ palm/trunk/SOURCE/palm.f90	(revision 1112)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! openACC statements updated
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1111 2013-03-08 23:54:10Z raasch
+! openACC statements updated
 !
 ! 1092 2013-02-02 11:24:22Z raasch
Index: palm/trunk/SOURCE/poisfft.f90
===================================================================
--- palm/trunk/SOURCE/poisfft.f90	(revision 1111)
+++ palm/trunk/SOURCE/poisfft.f90	(revision 1112)
@@ -20,8 +20,15 @@
 ! Current revisions:
 ! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1111 2013-03-08 23:54:10Z raasch
 ! further openACC porting of non-parallel (MPI) branch:
 ! tridiagonal routines split into extermal subroutines (instead using CONTAINS),
 ! no distinction between parallel/non-parallel in poisfft and tridia any more,
-! tridia routines moved to end of file because of probable bug in PGI compiler
+! tridia routines moved to end of file because of probable bug in PGI compiler 12.5
 ! (otherwise "invalid device function" is indicated during runtime),
 ! optimization of tridia routines: constant elements and coefficients of tri are
@@ -31,8 +38,4 @@
 ! poisfft_init,
 ! ibc_p_b = 2 removed
-!
-! Former revisions:
-! -----------------
-! $Id$
 !
 ! 1106 2013-03-04 05:31:38Z raasch
Index: palm/trunk/SOURCE/poisfft_hybrid.f90
===================================================================
--- palm/trunk/SOURCE/poisfft_hybrid.f90	(revision 1111)
+++ palm/trunk/SOURCE/poisfft_hybrid.f90	(revision 1112)
@@ -20,10 +20,13 @@
 ! Current revisions: 
 ! ----------------- 
-! poisfft_hybrid_ini is now called internally from poisfft_hybrid,
-! ibc_p_b = 2 removed
+! 
 !
 ! Former revisions: 
 ! ----------------- 
 ! $Id$
+!
+! 1111 2013-03-08 23:54:10Z raasch
+! poisfft_hybrid_ini is now called internally from poisfft_hybrid,
+! ibc_p_b = 2 removed
 !
 ! 1106 2013-03-04 05:31:38Z raasch
Index: palm/trunk/SOURCE/pres.f90
===================================================================
--- palm/trunk/SOURCE/pres.f90	(revision 1111)
+++ palm/trunk/SOURCE/pres.f90	(revision 1112)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! -----------------
-! openACC statements added,
-! ibc_p_b = 2 removed
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1111 2013-03-08 23:54:10Z
+! openACC statements added,
+! ibc_p_b = 2 removed
 !
 ! 1092 2013-02-02 11:24:22Z raasch
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 1111)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 1112)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! update directives for prognostic quantities removed
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1111 2013-03-08 23:54:10Z raasch
+! update directives for prognostic quantities removed
 !
 ! 1106 2013-03-04 05:31:38Z raasch
Index: palm/trunk/SOURCE/swap_timelevel.f90
===================================================================
--- palm/trunk/SOURCE/swap_timelevel.f90	(revision 1111)
+++ palm/trunk/SOURCE/swap_timelevel.f90	(revision 1112)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! openACC directives added
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1111 2013-03-08 23:54:10Z raasch
+! openACC directives added
 !
 ! 1053 2012-11-13 17:11:03Z hoffmann
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 1111)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1112)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! +internal timestep counter for cpu statistics added,
-! openACC directives updated
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1111 2013-03-08 23:54:10Z raasch
+! +internal timestep counter for cpu statistics added,
+! openACC directives updated
 !
 ! 1092 2013-02-02 11:24:22Z raasch
Index: palm/trunk/SOURCE/transpose.f90
===================================================================
--- palm/trunk/SOURCE/transpose.f90	(revision 1111)
+++ palm/trunk/SOURCE/transpose.f90	(revision 1112)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! -----------------
-! openACC directives added,
-! resorting data from/to work changed, work got 4 dimensions instead of 1
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1111 2013-03-08 23:54:10Z raasch
+! openACC directives added,
+! resorting data from/to work changed, work got 4 dimensions instead of 1
 !
 ! 1106 2013-03-04 05:31:38Z raasch